package cn.com.infosec.x509;

import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.x509.CertificatePair;
import cn.com.infosec.asn1.x509.X509CertificateStructure;
import cn.com.infosec.jce.provider.X509CertificateObject;
import java.io.IOException;
import java.security.cert.X509Certificate;

public class X509CertificatePair {
   private X509Certificate forward;
   private X509Certificate reverse;

   public X509CertificatePair(X509Certificate forward, X509Certificate reverse) {
      this.forward = forward;
      this.reverse = reverse;
   }

   public X509CertificatePair(CertificatePair pair) {
      if (pair.getForward() != null) {
         this.forward = new X509CertificateObject(pair.getForward());
      }

      if (pair.getReverse() != null) {
         this.reverse = new X509CertificateObject(pair.getReverse());
      }

   }

   public byte[] getEncoded() {
      X509CertificatePair var10000 = this;
      X509CertificateStructure var1 = null;
      X509CertificateStructure var2 = null;

      IllegalArgumentException var16;
      label58: {
         IOException var15;
         label62: {
            X509Certificate var17;
            boolean var10001;
            try {
               var17 = var10000.forward;
            } catch (IllegalArgumentException var11) {
               var16 = var11;
               var10001 = false;
               break label58;
            } catch (IOException var12) {
               var15 = var12;
               var10001 = false;
               break label62;
            }

            X509CertificateStructure var18;
            if (var17 != null) {
               try {
                  var18 = X509CertificateStructure.getInstance((new ASN1InputStream(this.forward.getEncoded())).readObject());
               } catch (IllegalArgumentException var9) {
                  var16 = var9;
                  var10001 = false;
                  break label58;
               } catch (IOException var10) {
                  var15 = var10;
                  var10001 = false;
                  break label62;
               }

               var1 = var18;
            }

            try {
               var17 = this.reverse;
            } catch (IllegalArgumentException var7) {
               var16 = var7;
               var10001 = false;
               break label58;
            } catch (IOException var8) {
               var15 = var8;
               var10001 = false;
               break label62;
            }

            if (var17 != null) {
               try {
                  var18 = X509CertificateStructure.getInstance((new ASN1InputStream(this.reverse.getEncoded())).readObject());
               } catch (IllegalArgumentException var5) {
                  var16 = var5;
                  var10001 = false;
                  break label58;
               } catch (IOException var6) {
                  var15 = var6;
                  var10001 = false;
                  break label62;
               }

               var2 = var18;
            }

            try {
               return (new CertificatePair(var1, var2)).getDEREncoded();
            } catch (IllegalArgumentException var3) {
               var16 = var3;
               var10001 = false;
               break label58;
            } catch (IOException var4) {
               var15 = var4;
               var10001 = false;
            }
         }

         IOException var13 = var15;
         throw new ExtCertificateEncodingException(var13.toString(), var13);
      }

      IllegalArgumentException var14 = var16;
      throw new ExtCertificateEncodingException(var14.toString(), var14);
   }

   public X509Certificate getForward() {
      return this.forward;
   }

   public X509Certificate getReverse() {
      return this.reverse;
   }

   public boolean equals(Object o) {
      if (o == null) {
         return false;
      } else if (!(o instanceof X509CertificatePair)) {
         return false;
      } else {
         X509CertificatePair o1 = (X509CertificatePair)o;
         boolean var2 = true;
         boolean var3 = true;
         X509Certificate var4;
         if ((var4 = this.forward) != null) {
            var3 = var4.equals(o1.forward);
         } else if (o1.forward != null) {
            var3 = false;
         }

         X509Certificate var5;
         if ((var5 = this.reverse) != null) {
            var2 = var5.equals(o1.reverse);
         } else if (o1.reverse != null) {
            var2 = false;
         }

         return var3 && var2;
      }
   }

   public int hashCode() {
      int var1 = 0;
      X509Certificate var2;
      if ((var2 = this.forward) != null) {
         var1 += var2.hashCode();
      }

      X509Certificate var3;
      if ((var3 = this.reverse) != null) {
         var1 += var3.hashCode();
      }

      return var1;
   }
}
